#!/usr/bin/python

from Xlib import display, X, XK
import Xlib

punc_map = {
  " " : "space",
  "`" : "grave",
  "[" : "bracketleft",
  "]" : "bracketright",
  "/" : "slash",
  "=" : "equal",
  "\\" : "backslash",
  "'" : "apostrophe",
  "," : "comma",
  "." : "period",
  ";" : "semicolon",
  "-" : "minus",
  "\n" : "Return",
  "\t" : "Tab",
}
capital_map = {
  "A" : "a",
  "B" : "b",
  "C" : "c",
  "D" : "d",
  "E" : "e",
  "F" : "f",
  "G" : "g",
  "H" : "h",
  "I" : "i",
  "J" : "j",
  "K" : "k",
  "L" : "l",
  "M" : "m",
  "N" : "n",
  "O" : "o",
  "P" : "p",
  "Q" : "q",
  "R" : "r",
  "S" : "s",
  "T" : "t",
  "U" : "u",
  "V" : "v",
  "W" : "w",
  "X" : "x",
  "Y" : "y",
  "Z" : "z",
  "~" : "`",
  "!" : "1",
  "@" : "2",
  "#" : "3",
  "$" : "4",
  "%" : "5",
  "^" : "6",
  "&" : "7",
  "*" : "8",
  "(" : "9",
  ")" : "0",
  "{" : "[",
  "}" : "]",
  "?" : "/",
  "+" : "=",
  "|" : "\\",
  "\"" : "'",
  "<" : ",",
  ">" : ".",
  ":" : ";",
  "_" : "-",
}

def SendXKeys(dpy, text):
  shiftsym = XK.string_to_keysym("Shift_L")
  shiftcode = dpy.keysym_to_keycode(shiftsym)
  for letter in text:
    #print "Letter: %s (%s)" % (ord(letter), letter)
    shift = 0
    if capital_map.has_key(letter):
      shift = 1
      letter = capital_map[letter]
    if punc_map.has_key(letter):
      letter = punc_map[letter]

    keysym = XK.string_to_keysym(letter)
    keycode = dpy.keysym_to_keycode(keysym)
    #print "\t%s: %s" % (letter, keycode)

    if shift:
      dpy.xtest_fake_input(X.KeyPress, shiftcode, 0)

    dpy.xtest_fake_input(X.KeyPress, keycode, 0)
    dpy.xtest_fake_input(X.KeyRelease, keycode, 0)

    if shift:
      dpy.xtest_fake_input(X.KeyRelease, shiftcode, 0)

  dpy.flush()

def run(args):
  for a in args:
    if a in ["-h", "--help"]:
      print "Usage: cat file | xtype [options]"
      print "Options:"
      print "\t-h\tThis help text."
      print "\t-n\tConvert returns to spaces."
      return

    elif a == "-n":
      punc_map["\n"] = "space"
  
  dpy = display.Display()
  for line in sys.stdin.xreadlines():
    SendXKeys(dpy, line)

if __name__ == "__main__":
  import sys

  args = sys.argv[1:]
  run(args)
